<%@ Page Language="vb" Strict="True"  %>
<%@ Import Namespace="system.io" %>
<%@ Import Namespace="System.Drawing" %> 
<script language="vb" runat="server">

  '******************************************************************
  '*  IDAutomation Streaming SSRS Barcode Generator DEMO 2019
  '*  Copyright, IDAutomation.com, Inc. All rights reserved.
  '******************************************************************
  '*  DEMO VERSION NOTICE:
  '*  The demo version of this product contains a static barcode that may be
  '*  used for evaluation purposes only. The static barcode cannot be
  '*  changed because this would reveal the complete formula, which is only
  '*  available in the purchased version. The purchased version is provided 
  '*  with a money back satisfaction guarantee. If it is necessary to 
  '*  test dynamic barcodes with this product, the purchased version is required.
  '*  http://www.idautomation.com/barcode-components/aspx-generator-script/#licensing
  '******************************************************************
  '*  Redistribution and use of this code in source and/or binary
  '*  forms, with or without modification, are permitted provided
  '*  that: (1) all copies of the source code retain the above
  '*  unmodified copyright notice and this entire unmodified
  '*  section of text, (2) You or Your organization owns a valid
  '*  Developer License to this product from IDAutomation.com
  '*  and, (3) when any portion of this code is bundled in any
  '*  form with an application, A valid notice must be provided
  '*  within the user documentation, start-up screen or in the
  '*  help-about section of the application that specifies
  '*  IDAutomation.com as the provider of the Software bundled
  '*  with the application.
  '******************************************************************

    Sub createBarcode()
        
        Dim i As Integer, height As Integer, width As Integer, lines As String(), lines2 As String(), count As Integer
        Dim k as Integer , xFactor as Integer, sTemp as String 
        
        xFactor = 3
        
        height = 23
        width = 23
	
        lines = New String() {}
        ReDim lines(height)
	
        lines(22) = "00000000000000000000000"
        lines(21) = "01111111000010011111110"
        lines(20) = "01000001001011010000010"
        lines(19) = "01011101001010010111010"
        lines(18) = "01011101010110010111010"
        lines(17) = "01011101010100010111010"
        lines(16) = "01000001000111010000010"
        lines(15) = "01111111010101011111110"
        lines(14) = "00000000011100000000000"
        lines(13) = "01110011101001000110000"
        lines(12) = "01111110000000010011010"
        lines(11) = "01110011100011100001100"
        lines(10) = "00000100001100101011100"
        lines(9) = "01000111011000000011100"
        lines(8) = "00000000011000100101000"
        lines(7) = "01111111010001000011100"
        lines(6) = "01000001011000100001110"
        lines(5) = "01011101001110010110000"
        lines(4) = "01011101000000010111100"
        lines(3) = "01011101000001010101110"
        lines(2) = "01000001010010100011000"
        lines(1) = "01111111011010010010100"
        lines(0) = "00000000000000000000000"

        
        lines2 = New String() {}
        ReDim lines2(height*xFactor)
        count = UBound(lines) - 1
        For i = 0 To count
          sTemp = widen(lines(i), xFactor)
          For k = 0 to xFactor - 1  
            lines2((i*xFactor) + k ) = sTemp
          Next  
        Next

        height = xFactor * height  
        width = xFactor * width  

		'' LM 2018.12.17 add support for image type PNG and JPEG  
		Dim options As Object()
		Dim imagetype as String
        options = New Object() {"imagetype", "I", 3, "BMP"}	
	
        Dim conf As System.Collections.Generic.Dictionary(Of String, Object)
        conf = New System.Collections.Generic.Dictionary(Of String, Object)
        
		conf.Add(CStr(options(0)), Request.QueryString(CStr(options(1))))
		If CStr(conf(CStr(options(0)))) = "" Then conf(CStr(options(0))) = options(3)
        imagetype = CStr(conf("imagetype"))
		If ((imagetype <> "PNG") AND (imagetype <> "JPG") AND (imagetype <> "JPEG") AND (imagetype <> "BMP") ) Then imagetype = "BMP"
		
		'' BMP image with 1 bit color depth
		if (imagetype = "BMP") Then					
			Response.ContentType = "image/bmp"
			Response.BinaryWrite(GetBMP(lines2, height, width))  				
		
		Else 
		
			'' LM 2018.12.17 add support for image type PNG and JPEG
			Dim ms As MemoryStream = New MemoryStream
			Dim newimage As New Bitmap(width, height)
			Dim gr As Graphics = Graphics.FromImage(newimage)
			Dim blackBrush as New SolidBrush(Color.Black)	
			Dim dotRect as Rectangle

			gr.Clear(Color.White)
			For i = 0 to height -1
				For k = 0 to width -1
					if Mid(lines2(i), k+1,1) = "1" then
						dotRect = new Rectangle(k, (height -1) - i, 1,1)
						gr.FillRectangle(blackBrush, dotRect)
					end if  
				Next
			Next  				
							

			if (imagetype = "PNG") Then
				Response.ContentType = "image/png"
				newimage.Save(ms, System.Drawing.Imaging.ImageFormat.png)				
			elseif (imagetype = "JPEG" OR imagetype = "JPG") Then
				Response.ContentType = "image/jpeg"
				newimage.Save(ms, System.Drawing.Imaging.ImageFormat.jpeg)				
			End if
			
			Dim b() As Byte = ms.ToArray
			response.binarywrite(b)						
		
		End If		
		
		
    End Sub

    '' Create BMP stream
    Private Function GetBMP(ByRef Matrix() As String, ByVal SizeY As Integer, ByVal SizeX As Integer) As Byte()    

      Dim y As Integer
      Dim x As Integer
      Dim k As Integer
      Dim intTemp As Integer
      
      Dim pixels As Integer
      Dim pos As Integer
      
      Dim height As Long
      Dim width As Long
      
      Dim Stream() As Byte
      Dim rowbytes As Long
      Dim nPos As Integer
      Dim i As Long
      Dim intPad As Integer

      height = SizeY 
      width = SizeX 
      
      
      intPad = 0
      intTemp = CInt(((width \ 8) + CInt(IIf(width Mod 8 > 0, 1, 0))) Mod 4)
      If intTemp <> 0 Then intPad = 4 - intTemp
      
      rowbytes = (width \ 8) +  CInt(IIf(width Mod 8 > 0, 1, 0)) + intPad
      ReDim Stream(CInt(rowbytes * height) + 62 - 1)
      
      Stream(0) = 66
      Stream(1) = 77
      Stream(10) = 62
      Stream(14) = 40
      Stream(18) = CByte(width Mod 256)
      Stream(19) = CByte(width \ 256)
      Stream(22) = CByte(height Mod 256)
      Stream(23) = CByte(height \ 256)
      Stream(26) = 1
      Stream(28) = 1
      Stream(38) = 37
      Stream(39) = 14
      Stream(42) = 37
      Stream(43) = 14
      Stream(54) = 255
      Stream(55) = 255
      Stream(56) = 255
      
      nPos = 62
      For y = 0 to SizeY - 1 '' for each row
        pixels = 0
        pos = 8
        For x = 0 To SizeX - 1 '' for each column
          pos = pos - 1
          If Mid(Matrix(y), x+1,1) = "1" Then pixels = CInt(pixels + 2 ^ pos)
          If pos = 0 Then
            Stream(nPos) = CByte(pixels)
            nPos = nPos + 1
            pos = 8
            pixels = 0
          End If 
        Next
        
        If pos <> 8 Then
          Stream(nPos) = CByte(pixels)
          nPos = nPos + 1
        End If
        nPos = nPos + intPad 
      Next
      
      GetBMP = Stream
    End Function  	
	
    Function widen(ByVal code As String, ByVal XDim As Integer) As String
        If XDim = 1 Then
          widen = code
        Else
          widen = Replace( Replace( code, "0", Replace( Space(XDim), " ", "0") ) , "1", Replace(Space(XDim), " ", "1") )
        End If
    End Function    
    
   
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Call createBarcode()
    End Sub
    
</script>

